// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/./Applications/OmniCD/OmniCDDB/CDDBPreferences.h,v 1.3 2000/09/12 19:07:51 bungi Exp $

#import <AppKit/AppKit.h>
#import <OmniAppKit/OAPreferenceClient.h>

extern NSString *CDDBServerAutoQueryDefaultKey;
extern NSString *CDDBServerProtocolDefaultKey;
extern NSString *CDDBServerHostNameDefaultKey;
extern NSString *CDDBServerPortDefaultKey;
extern NSString *CDDBHTTPFormPathDefaultKey;
extern NSString *CDDBHTTPUseProxyDefaultKey;
extern NSString *CDDBHTTPProxyHostNameDefaultKey;
extern NSString *CDDBHTTPProxyPortDefaultKey;

extern NSString *CDDDCDDBPProtocolName;
extern NSString *CDDDHTTPProtocolName;

@interface CDDBPreferences : OAPreferenceClient
{
    IBOutlet NSButton      *cddbAutoQueryButton;
    IBOutlet NSTextField   *cddbServerHostNameField;
    IBOutlet NSTextField   *cddbServerPortField;
    IBOutlet NSPopUpButton *cddbProtocolPopUpButton;
    IBOutlet NSTextField   *httpFormPathField;
    IBOutlet NSButton      *useHTTPProxyButton;
    IBOutlet NSTextField   *httpProxyHostNameField;
    IBOutlet NSTextField   *httpProxyPortField;

    IBOutlet NSWindow      *cddbServerListWindow;
    IBOutlet NSTableView   *cddbServerListTableView;
    IBOutlet NSTableColumn *cddbServerDescriptionTableColumn;
    IBOutlet NSTableColumn *cddbServerHostNameTableColumn;
    IBOutlet NSTableColumn *cddbServerPortTableColumn;
    IBOutlet NSTableColumn *cddbServerProtocolTableColumn;

    NSArray *_cddbServers;
}

- (IBAction) selectServer: (id) sender;
- (IBAction) selectServerOk: (id) sender;
- (IBAction) selectServerCancel: (id) sender;

- (IBAction) refreshServerList: (id) sender;

@end
